﻿using MVCSampleBrowser.Models;
using Sample.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using Syncfusion.JavaScript.Web;
using System;
using System.Collections.Generic;
using System.Collections;
using System.Web.Script.Serialization;
using System.Linq;
using System.Web;
using System.Web.Script.Services;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Sample
{
    public partial class Default : System.Web.UI.Page
    {
        public IEnumerable AutoDataSource;
        IEnumerable a = new NorthwndDataContext().Orders.ToList();
        private List<Orders> order = new List<Orders>();
        protected void Page_Load(object sender, EventArgs e)
        {
            BindDataSource();
             bindcountry();
            Session["DialogDataSource"] = order;
        }

        private void BindDataSource()
        {
            if ((List<Orders>)Session["DialogDataSource"] == null)
            {
                int orderId = 10643;
                int empId = 0;
                for (int i = 1; i < 9; i++)
                {
                    order.Add(new Orders(orderId + 1, "Alfreds Futterkiste ", "Germany"));
                    order.Add(new Orders(orderId + 2, "Ana Trujillo Emparedados y helados", "Mexico"));
                    order.Add(new Orders(orderId + 3, "Antonio Moreno Taquería", "Mexico"));
                    order.Add(new Orders(orderId + 4, "Around the Horn", "UK"));
                    order.Add(new Orders(orderId + 5, "Berglunds snabbköp", "Sweden"));
                    order.Add(new Orders(orderId + 6, "Blondel père et fils", "France"));
                    orderId += 6;
                    empId += 6;
                }
            }
            else
            {
                order = (List<Orders>)Session["DialogDataSource"];
            }
            
            this.Grid.DataSource = order;
            this.Grid.DataBind();
        }


        private void bindcountry()
        {


            List<Countries> c = new List<Countries>();
            c.Add(new Countries { text = "Austria", ID = "100001" });
            c.Add(new Countries { text = "Australia", ID = "20002" });
            c.Add(new Countries { text = "Bangladesh", ID = "300003" });

            this.AutoDataSource = a;
            this.ShipCountry.DataSource = c;
            ShipCountry.DataTextField = "text";
            ShipCountry.DataUniqueKeyField = "ID";
            ShipCountry.DataBind();



        }

        [Serializable]
        class Countries
        {
            public string text;
            public string ID;
        }




        protected void EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            var item = this.autoComp.Value;
            JavaScriptSerializer mySerialiser = new JavaScriptSerializer();
            var data = mySerialiser.Deserialize<object>(item); // here you will get records



            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerAddRow(object sender, GridEventArgs e)
        {
            var item = this.autoComp.Value;
            JavaScriptSerializer mySerialiser = new JavaScriptSerializer();
            var data = mySerialiser.Deserialize<object>(item); // here you will get records

            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerDeleteRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditAction(string eventType, object record)
        {
            List<Orders> data = Session["DialogDataSource"] as List<Orders>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
            if (eventType == "endEdit")
            {
                Orders value = new Orders();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "OrderID")
                    {
                        value = data.Where(d => d.OrderID == (int)keyval.Value).FirstOrDefault();
                        value.OrderID = Convert.ToInt32(keyval.Value);
                    }

                    else if (keyval.Key == "ShipCountry")
                        value.ShipCountry = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "ShipName")
                        value.ShipName = Convert.ToString(keyval.Value);
                }
            }

            else if (eventType == "endAdd")
            {
                Orders newRecord = new Orders();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "OrderID")
                        newRecord.OrderID = Convert.ToInt32(keyval.Value);

                    else if (keyval.Key == "ShipCountry")
                        newRecord.ShipCountry = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "ShipName")
                        newRecord.ShipName = Convert.ToString(keyval.Value);

                }
                data.Insert(0, newRecord);
            }

            else if (eventType == "endDelete")
            {
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {
                    if (keyval.Key == "OrderID")
                    {
                        Orders value = data.Where(d => d.OrderID == (int)keyval.Value).FirstOrDefault();
                        data.Remove(value);
                    }
                }
            }
            Session["DialogDataSource"] = data;
            this.Grid.DataSource = data;
            this.Grid.DataBind();
        }

        [Serializable]
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(int orderId, string shipName, string shipCountry)
            {
                this.OrderID = orderId;

                this.ShipCountry = shipCountry;
                this.ShipName = shipName;
            }
            public int OrderID { get; set; }

            public string ShipCountry { get; set; }
            public string ShipName { get; set; }
        }

    }
  }
